package com.sq.customization.util;

import java.text.DecimalFormat;

import org.apache.poi.ss.usermodel.Cell;
import org.apache.poi.ss.usermodel.DateUtil;

public class ExcelUtil {
	public static String getStringCellValue(Cell cell)
	{
		String strCell = "";
		if(cell == null)
			return "";
		switch(cell.getCellType()){
			case Cell.CELL_TYPE_STRING :
				strCell = cell.getStringCellValue();
				break;
			case Cell.CELL_TYPE_NUMERIC :
				if(DateUtil.isCellDateFormatted(cell))
					strCell = cell.getDateCellValue().toString();
				else
			//		strCell = String.valueOf(cell.getNumericCellValue());
					strCell = new DecimalFormat("#").format(cell.getNumericCellValue());
				break;
			case Cell.CELL_TYPE_BOOLEAN :
				strCell = String.valueOf(cell.getBooleanCellValue());
				break;
			case Cell.CELL_TYPE_FORMULA :
				strCell = cell.getCellFormula();
				break;
			case Cell.CELL_TYPE_BLANK :
				strCell = "";
				break;
			default:
				strCell = "";
				break;
		}
		if(strCell == null || strCell.equals(""))
			return "";
		
		return strCell;
	}
}
